# SQL Databases

## Overview

## Generic Database Interface

::: tip usage
(import :std/db/dbi)
:::

### connection?
::: tip usage
```
(connection? obj) -> boolean
```
:::

Returns #t if the arguemnt is an sql connection object.

### statement?
::: tip usage
```
(statement? obj) -> boolean
```
:::

Returns #t if the argument is an sql statement object.

### sql-error?
::: tip usage
```
(sql-error? ...)
```
:::

Please document me!

### sql-connect
::: tip usage
```
(sql-connect ...)
```
:::

Please document me!

### sql-close
::: tip usage
```
(sql-close ...)
```
:::

Please document me!

### sql-prepare
::: tip usage
```
(sql-prepare str) -> statement
   str := string that is a valid sql statement
```
:::

Converts an sql statement in string form to a statement object to be used with
connections established via `sql-connect`.

### sql-bind
::: tip usage
```
(sql-bind ...)
```
:::

Please document me!

### sql-clear
::: tip usage
```
(sql-clear ...)
```
:::

Please document me!

### sql-reset
::: tip usage
```
(sql-reset ...)
```
:::

Please document me!

### sql-reset/clear
::: tip usage
```
(sql-reset/clear ...)
```
:::

Please document me!

### sql-finalize
::: tip usage
```
(sql-finalize ...)
```
:::

Please document me!

### sql-eval
::: tip usage
```
(sql-eval ...)
```
:::

Please document me!

### sql-eval-query
::: tip usage
```
(sql-eval-query ...)
```
:::

Please document me!

### sql-exec
::: tip usage
```
(sql-exec obj)
   obj := sql statement object
```
:::

Accepts an sql statement object as an argument. Defaults to currently open
connection made via `(sql-connect sqlite-open ...)`.

### sql-query
::: tip usage
```
(sql-query ...)
```
:::

Please document me!

### in-sql-query
::: tip usage
```
(in-sql-query ...)
```
:::

Please document me!

### sql-columns
::: tip usage
```
(sql-columns ...)
```
:::

Please document me!

### sql-txn-begin
::: tip usage
```
(sql-txn-begin ...)
```
:::

Please document me!

### sql-txn-commit
::: tip usage
```
(sql-txn-commit ...)
```
:::

Please document me!

### sql-txn-abort
::: tip usage
```
(sql-txn-abort ...)
```
:::

Please document me!



## SQLite driver

::: tip usage
(import :std/db/sqlite)
:::

### sqlite-open
::: tip usage
```
(sql-connect sqlite-open str)
   str	:= a relative filepath or sqlite connection string
```
:::

Opens an sql connection to the database located at the provided path/address.


## PostgreSQL driver

::: tip usage
(import :std/db/postgresql)
:::

### postgresql-connect
::: tip usage
```
(sql-connect postgresql-connect ...)
```
:::

Please document me!

### defcatalog
::: tip usage
```
(defcatalog ...)
```
:::

Please document me!

### defcatalog-default
::: tip usage
```
(defcatalog-default ...)
```
:::

Please document me!

### default-catalog
::: tip usage
```
(def default-catalog)
```
:::

Please document me!

### current-catalog
::: tip usage
```
(current-catalog ...)
```
:::

Please document me!


## MySQL driver

::: tip usage
(import :std/db/mysql)
:::

### mysql-connect
::: tip usage
```
(sql-connect mysql-connect ...)
```
:::

Please document me!

## Connection Pools

::: tip usage
(import :std/db/conpool)
:::

### make-conpool
::: tip usage
```
(make-conpool ...)
```
:::

Please document me!

### conpool?
::: tip usage
```
(conpool? ...)
```
:::

Please document me!

### conpool-get
::: tip usage
```
(conpool-get ...)
```
:::

Please document me!

### conpool-put
::: tip usage
```
(conpool-put ...)
```
:::

Please document me!

### conpool-release
::: tip usage
```
(conpool-release ...)
```
:::

Please document me!

### conpool-close
::: tip usage
```
(conpool-close ...)
```
:::

Please document me!

## Example
