(import :std/db/dbi
	:std/db/sqlite )

(define local-db
   (sql-connect sqlite-open "test.sqlite") )
(define query-db (lambda (query connection)
   (cond ((not (connection? connection))
         (error "(ARGUMENT 2) CONNECTION expected") )
      ((not (string? query))
         (error "(ARGUMENT 1) STRING expected"))
      ((and (connection? connection) (string? query))
         (sql-query (sql-prepare connection query)))
      (else error "Unkown Error. Please report a bug :)") ) ))
(define exec-db (lambda (exec connection)
   (cond ((not (connection? connection))
         (error "(ARGUMENT 2) CONNECTION expected") )
      ((not (string? exec))
         (error "(ARGUMENT 1) STRING expected"))
      ((and (connection? connection) (string? exec))
         (sql-exec (sql-prepare connection exec)))
      (else error "Unkown Error. Please report a bug :)") ) ))
